
#include "stos.h"

Stos *initStos()
{
  Stos *s = (Stos*)malloc(sizeof(Stos));
  s->top=NULL;
  s->size=0;
  return s;
}

void push(Stos *s, int k)
{
  Elem *e = (Elem*)malloc(sizeof(Elem));
  e->k=k;
  e->next=s->top;
  s->top=e;
  s->size++;
}

int pop(Stos *s)
{
  Elem *e = s->top;
  int k;
  if (e==NULL)
    {
      fprintf(stderr,"POP na pustym stosie!\n");
      exit(-1);
    } 
  k=e->k;
  s->top=s->top->next;
  free(e);
  s->size--;
  return k;
}

int isEmpty(Stos *s)
{
  return s->top==NULL;  /* rownowaznie: return s->top; */
}

void fprintStos(FILE *f, Stos *s)
{
  Elem *e = s->top;
  fprintf(f,"[ ");
  while (e)  /* lub e!=NULL */
    {
      fprintf(f,"%d ",e->k);
      e=e->next;
    }
  fprintf(f,"]\n");
}


void freeStos(Stos *s)
{
  while (!isEmpty(s)) 
    pop(s); 
  free(s);
}
